function get_diagnostic_event_struct_c, secondsSince1996
    fileSuffix = 'de'
    structToUse = {L1CrisDiagnosticEvent}

	; find the correct sample interval which is dependent on the start
	; and stop times in the structs
    baseDir = getenv('L1_CRIS_DATA_BASE_DIRECTORY')
    date = cvtfromsec1996(secondsSince1996)
    path = generate_data_file_path(baseDir, date, fileSuffix)
    startAndStop =							    $
	get_begin_end_secs_of_struct_prior_to(secondsSince1996,	    $
							path, structToUse)
    if ((secondsSince1996 GE startAndStop[0]) AND			    $
			(secondsSince1996 LE startAndStop[1])) then begin
	    ; if the struct with the time stamp just earlier than
	    ; secondsSince1996 contains secondsSince1996 between
	    ; its stop and start, then use a start time 1 less than said
	    ; struct's time stamp to be sure to gather it into the group read.
	getStampsAfter = startAndStop[0] - 1
    endif								    $
    else if (startAndStop[1] EQ 0) then begin
	    ; no prior struct was found in this or the previous day.
	    ; set start time to 1 second less than start of this
	    ; day to get all time stamps inside this day.
	date.hour = 0
	date.min = 0
	date.sec = 0
	seconds1996At12AM = CvtToSec1996(date)
	getStampsAfter = seconds1996At12AM - 1
    endif								    $
    else begin
	    ; secondsSince1996 is after the previous struct's end time,
	    ; so use that end time as the marker to get structs that follow it
	getStampsAfter = startAndStop[1]
    endelse
    sampleInterval = secondsSince1996 - getStampsAfter

    structs = get_struct(secondsSince1996, fileSuffix, structToUse, 'c',    $
							sampleInterval)
    return, structs
end
